Index: trunk/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncEntropy.h	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncEntropy.h	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 
 
@@ -57,10 +90,9 @@
   
   virtual Void codeSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
-#if MW_MVI_SIGNALLING_MODE == 0
-  virtual Void codeMvInheritanceFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
-#endif
   virtual Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
   virtual Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   virtual Void codeResPredFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx ) = 0;
+#endif
   virtual Void codeSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
   
@@ -138,7 +170,4 @@
   Void encodeSplitFlag         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, Bool bRD = false );
   Void encodeSkipFlag          ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
-#if MW_MVI_SIGNALLING_MODE == 0
-  Void encodeMvInheritanceFlag ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, Bool bRD = false );
-#endif
   Void encodePUWise       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
   Void encodeInterDirPU   ( TComDataCU* pcSubCU, UInt uiAbsPartIdx  );
@@ -152,5 +181,7 @@
   Void encodeMergeIndex   ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPUIdx );
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   Void encodeResPredFlag  ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPUIdx, Bool bRD = false );
+#endif
   Void encodeAlfCtrlFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD = false );
 #if TSB_ALF_HEADER
Index: trunk/source/Lib/TLibEncoder/TEncFormattedStringParser.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncFormattedStringParser.cpp	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncFormattedStringParser.cpp	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 
 #include "TEncFormattedStringParser.h"
Index: trunk/source/Lib/TLibEncoder/TEncFormattedStringParser.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncFormattedStringParser.h	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncFormattedStringParser.h	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 #if !defined(AFX_TEncFormattedStringParser_H__268768B8_4D1D_484A_904E_586985833BAC__INCLUDED_)
 #define AFX_TEncFormattedStringParser_H__268768B8_4D1D_484A_904E_586985833BAC__INCLUDED_
Index: trunk/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 
 
@@ -13,5 +46,4 @@
 #include <time.h>
 
-// SB
 #include "../../App/TAppEncoder/TAppEncTop.h"
 
@@ -25,12 +57,16 @@
   m_pcSliceEncoder      = NULL;
   m_pcListPic           = NULL;
-  
+
   m_pcEntropyCoder      = NULL;
   m_pcCavlcCoder        = NULL;
   m_pcSbacCoder         = NULL;
   m_pcBinCABAC          = NULL;
+#if DEPTH_MAP_GENERATION
   m_pcDepthMapGenerator = NULL;
+#endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   m_pcResidualGenerator = NULL;
-  
+#endif
+
 #if DCM_DECODING_REFRESH
   m_bRefreshPending     = 0;
@@ -69,5 +105,5 @@
   m_pcSliceEncoder       = pcTEncTop->getSliceEncoder();
   m_pcListPic            = pcTEncTop->getListPic();
-  
+
   m_pcEntropyCoder       = pcTEncTop->getEntropyCoder();
   m_pcCavlcCoder         = pcTEncTop->getCavlcCoder();
@@ -76,7 +112,11 @@
   m_pcLoopFilter         = pcTEncTop->getLoopFilter();
   m_pcBitCounter         = pcTEncTop->getBitCounter();
+#if DEPTH_MAP_GENERATION
   m_pcDepthMapGenerator  = pcTEncTop->getDepthMapGenerator();
+#endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   m_pcResidualGenerator  = pcTEncTop->getResidualGenerator();
-  
+#endif
+
   // Adaptive Loop filter
   m_pcAdaptiveLoopFilter = pcTEncTop->getAdaptiveLoopFilter();
@@ -97,5 +137,5 @@
 {
   TComSlice*      pcSlice;
-  
+
       //-- For time output for each slice
       long iBeforeTime = clock();
@@ -104,5 +144,5 @@
       pcBitstreamOut->resetBits();
       pcBitstreamOut->rewindStreamPacket();
-      
+
       //  Slice data initialization
       pcPic->clearSliceBuffer();
@@ -112,5 +152,5 @@
       m_pcSliceEncoder->initEncSlice ( pcPic, pcSlice );
       pcSlice->setSliceIdx(0);
-      
+
       //  Set SPS
       pcSlice->setSPS( m_pcEncTop->getSPS() );
@@ -120,5 +160,5 @@
   // set mutliview parameters
       pcSlice->initMultiviewSlice( pcPic->getCodedScale(), pcPic->getCodedOffset() );
-      
+
 #if DCM_DECODING_REFRESH
       // Set the nal unit type
@@ -129,5 +169,5 @@
 
       //pcSlice->setNalUnitType(getNalUnitType(uiPOCCurr));
-      // Do decoding refresh marking if any 
+      // Do decoding refresh marking if any
       pcSlice->decodingRefreshMarking(m_uiPOCCDR, m_bRefreshPending, rcListPic);
 #endif
@@ -140,21 +180,23 @@
 
   pcSlice->setRefPicListFromGOPSTring( rcListPic, apcSpatRefPics );
+
+#if HHI_VSO
   m_pcEncTop->getEncTop()->setMVDPic(pcPic->getViewIdx(), pcSlice->getPOC(), pcPic->getMVDReferenceInfo() );
 
-//GT VSO
-  Bool bUseVSO = m_pcEncTop->getUseVSO(); 
+
+  Bool bUseVSO = m_pcEncTop->getUseVSO();
   m_pcRdCost->setUseVSO( bUseVSO );
 
   if ( bUseVSO )
-  { 
+  {
     Int iVSOMode = m_pcEncTop->getVSOMode();
-    m_pcRdCost->setVSOMode( iVSOMode  );    
-#if RDO_DIST_INT
-    m_pcRdCost->setAllowNegDist( m_pcEncTop->getAllowNegDist() ); 
+    m_pcRdCost->setVSOMode( iVSOMode  );
+#if HHI_VSO_DIST_INT
+    m_pcRdCost->setAllowNegDist( m_pcEncTop->getAllowNegDist() );
 #endif
 
     if ( iVSOMode == 4 )
     {
-      m_pcEncTop->getEncTop()->setupRenModel( pcSlice->getPOC(), pcPic->getViewIdx(), m_pcEncTop->isDepthCoder() ? 1 : 0 ); 
+      m_pcEncTop->getEncTop()->setupRenModel( pcSlice->getPOC(), pcPic->getViewIdx(), m_pcEncTop->isDepthCoder() ? 1 : 0 );
     }
     else
@@ -163,11 +205,13 @@
   }
   }
-//GT VSO end
-
-  if ( m_pcEncTop->getOmitUnusedBlocks() )
-  {
-    m_pcEncTop->getEncTop()->getUsedPelsMap( pcPic->getViewIdx(), pcPic->getPOC(), pcPic->getUsedPelsMap() ); 
-  }
-      
+#endif
+
+#if HHI_INTERVIEW_SKIP
+  if ( m_pcEncTop->getInterViewSkip() )
+  {
+    m_pcEncTop->getEncTop()->getUsedPelsMap( pcPic->getViewIdx(), pcPic->getPOC(), pcPic->getUsedPelsMap() );
+  }
+#endif
+
       pcSlice->setNoBackPredFlag( false );
 #if DCM_COMB_LIST
@@ -183,5 +227,5 @@
           for ( i=0; i < pcSlice->getNumRefIdx(RefPicList( 1 ) ); i++ )
           {
-            if ( pcSlice->getRefPOC(RefPicList(1), i) != pcSlice->getRefPOC(RefPicList(0), i) ) 
+            if ( pcSlice->getRefPOC(RefPicList(1), i) != pcSlice->getRefPOC(RefPicList(0), i) )
             {
               pcSlice->setNoBackPredFlag( false );
@@ -199,5 +243,5 @@
       pcSlice->generateCombinedList();
 #endif
-      
+
       /////////////////////////////////////////////////////////////////////////////////////////////////// Compress a slice
       //  Slice compression
@@ -237,9 +281,15 @@
       m_uiStoredStartCUAddrForEncodingEntropySlice[uiStartCUAddrEntropySliceIdx++]  = uiNextCUAddr;
 
+#if DEPTH_MAP_GENERATION
       // init view component and predict virtual depth map
       m_pcDepthMapGenerator->initViewComponent( pcPic );
       m_pcDepthMapGenerator->predictDepthMap  ( pcPic );
+#if HHI_INTER_VIEW_MOTION_PRED
       m_pcDepthMapGenerator->covertOrgDepthMap( pcPic );
+#endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
       m_pcResidualGenerator->initViewComponent( pcPic );
+#endif
+#endif
 
       while(uiNextCUAddr<pcPic->getPicSym()->getNumberOfCUsInFrame()) // determine slice boundaries
@@ -262,8 +312,8 @@
             m_uiStoredStartCUAddrForEncodingEntropySlice[uiStartCUAddrEntropySliceIdx++]  = uiStartCUAddrSlice;
           }
-          
+
           if (uiStartCUAddrSlice < pcPic->getPicSym()->getNumberOfCUsInFrame())
           {
-            pcPic->allocateNewSlice();          
+            pcPic->allocateNewSlice();
             pcPic->setCurrSliceIdx                  ( uiStartCUAddrSliceIdx-1 );
             m_pcSliceEncoder->setSliceIdx           ( uiStartCUAddrSliceIdx-1 );
@@ -286,5 +336,5 @@
           uiStartCUAddrSlice                                                            = pcSlice->getSliceCurEndCUAddr();
           uiStartCUAddrEntropySlice                                                     = pcSlice->getEntropySliceCurEndCUAddr();
-        }        
+        }
 
         uiNextCUAddr = (uiStartCUAddrSlice > uiStartCUAddrEntropySlice) ? uiStartCUAddrSlice : uiStartCUAddrEntropySlice;
@@ -292,5 +342,5 @@
       m_uiStoredStartCUAddrForEncodingSlice[uiStartCUAddrSliceIdx++]                = pcSlice->getSliceCurEndCUAddr();
       m_uiStoredStartCUAddrForEncodingEntropySlice[uiStartCUAddrEntropySliceIdx++]  = pcSlice->getSliceCurEndCUAddr();
-      
+
       pcSlice = pcPic->getSlice(0);
 #if MTK_SAO  // PRE_DF
@@ -298,9 +348,12 @@
 #endif
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
       // set residual picture
       m_pcResidualGenerator->setRecResidualPic( pcPic );
-
+#endif
+#if DEPTH_MAP_GENERATION
       // update virtual depth map
       m_pcDepthMapGenerator->updateDepthMap( pcPic );
+#endif
 
       //-- Loop filter
@@ -329,6 +382,6 @@
             for(UInt i=0; i< uiNumSlices ; i++)
             {
-              (*m_pcAdaptiveLoopFilter)[i].create(pcPic, i, 
-                                                  m_uiStoredStartCUAddrForEncodingSlice[i], 
+              (*m_pcAdaptiveLoopFilter)[i].create(pcPic, i,
+                                                  m_uiStoredStartCUAddrForEncodingSlice[i],
                                                   m_uiStoredStartCUAddrForEncodingSlice[i+1]-1
                                                   );
@@ -359,5 +412,5 @@
         // generate start code
         bs_SPS_PPS_SEI.write( 1, 32);
-        
+
         m_pcEntropyCoder->encodePPS( pcSlice->getPPS() );
         bs_SPS_PPS_SEI.write( 1, 1 );
@@ -367,15 +420,15 @@
         rbSeqFirst = false;
       }
-      
+
       /* use the main bitstream buffer for storing the marshalled picture */
       m_pcEntropyCoder->setBitstream(pcBitstreamOut);
 
       uiStartCUAddrSliceIdx = 0;
-      uiStartCUAddrSlice    = 0; 
+      uiStartCUAddrSlice    = 0;
       pcBitstreamOut->allocateMemoryForSliceLocations( pcPic->getPicSym()->getNumberOfCUsInFrame() ); // Assuming number of slices <= number of LCU. Needs to be changed for sub-LCU slice coding.
       pcBitstreamOut->setSliceCount( 0 );                                      // intialize number of slices to zero, used while converting RBSP to NALU
 
       uiStartCUAddrEntropySliceIdx = 0;
-      uiStartCUAddrEntropySlice    = 0; 
+      uiStartCUAddrEntropySlice    = 0;
       uiNextCUAddr                 = 0;
       pcSlice = pcPic->getSlice(uiStartCUAddrSliceIdx);
@@ -401,5 +454,5 @@
           uiStartCUAddrSliceIdx++;
           uiStartCUAddrEntropySliceIdx++;
-        } 
+        }
         else if (uiNextCUAddr == m_uiStoredStartCUAddrForEncodingEntropySlice[uiStartCUAddrEntropySliceIdx])
         {
@@ -422,12 +475,6 @@
 
       // write SliceHeader
-#if SB_DEBUG
-      g_bEncoding = true ;
-#endif
       m_pcEntropyCoder->encodeSliceHeader ( pcSlice                 );
-#if SB_DEBUG
-      g_bEncoding = false ;
-#endif
-      
+
       // is it needed?
       if ( pcSlice->getSymbolMode() )
@@ -437,5 +484,5 @@
         m_pcEntropyCoder->resetEntropy    ();
       }
-      
+
         if (uiNextCUAddr==0)  // Compute ALF params and write only for first slice header
         {
@@ -452,5 +499,5 @@
 #endif
             m_pcAdaptiveLoopFilter->allocALFParam(&cAlfParam);
-            
+
             // set entropy coder for RD
             if ( pcSlice->getSymbolMode() )
@@ -464,5 +511,5 @@
             m_pcEntropyCoder->resetEntropy    ();
             m_pcEntropyCoder->setBitstream    ( m_pcBitCounter );
-            
+
             m_pcAdaptiveLoopFilter->startALFEnc(pcPic, m_pcEntropyCoder );
 #if MTK_SAO  // PostDF
@@ -478,5 +525,5 @@
 #endif
             UInt uiMaxAlfCtrlDepth;
-            
+
             UInt64 uiDist, uiBits;
 #if MTK_SAO
@@ -489,10 +536,7 @@
 #endif
             m_pcAdaptiveLoopFilter->endALFEnc();
-            
+
             // set entropy coder for writing
             m_pcSbacCoder->init( (TEncBinIf*)m_pcBinCABAC );
-#if SB_DEBUG
-            g_bEncoding = true;
-#endif           
             if ( pcSlice->getSymbolMode() )
             {
@@ -527,5 +571,5 @@
 #endif
             m_pcEntropyCoder->encodeAlfParam(&cAlfParam);
-            
+
 #if TSB_ALF_HEADER
             if(cAlfParam.cu_control_flag)
@@ -534,25 +578,18 @@
             }
 #endif
-            g_bEncoding = false;
             m_pcAdaptiveLoopFilter->freeALFParam(&cAlfParam);
           }
         }
-        
+
         // File writing
-#if SB_DEBUG
-        g_bEncoding = true ;
-#endif
         m_pcSliceEncoder->encodeSlice( pcPic, pcBitstreamOut );
-#if SB_DEBUG
-        g_bEncoding = false ;
-#endif
-        
+
         //  End of bitstream & byte align
         pcBitstreamOut->write( 1, 1 );
         pcBitstreamOut->writeAlignZero();
-        
+
         UInt uiBoundingAddrSlice, uiBoundingAddrEntropySlice;
-        uiBoundingAddrSlice        = m_uiStoredStartCUAddrForEncodingSlice[uiStartCUAddrSliceIdx];          
-        uiBoundingAddrEntropySlice = m_uiStoredStartCUAddrForEncodingEntropySlice[uiStartCUAddrEntropySliceIdx];          
+        uiBoundingAddrSlice        = m_uiStoredStartCUAddrForEncodingSlice[uiStartCUAddrSliceIdx];
+        uiBoundingAddrEntropySlice = m_uiStoredStartCUAddrForEncodingEntropySlice[uiStartCUAddrEntropySliceIdx];
         uiNextCUAddr               = min(uiBoundingAddrSlice, uiBoundingAddrEntropySlice);
         if (uiNextCUAddr < pcPic->getPicSym()->getNumberOfCUsInFrame())   // if more slices to be encoded insert start code
@@ -564,6 +601,6 @@
         }
       } // end iteration over slices
-      
-      
+
+
 #if MTK_NONCROSS_INLOOP_FILTER
       if(pcSlice->getSPS()->getUseALF())
@@ -572,35 +609,19 @@
           m_pcAdaptiveLoopFilter->destroySlice();
       }
-#endif 
-      
-      
+#endif
+
+
       pcBitstreamOut->flushBuffer();
       pcBitstreamOut->convertRBSPToPayload(0);
-      
+
 /*#if AMVP_BUFFERCOMPRESS
       pcPic->compressMotion(); // moved to end of access unit
 #endif */
       pcBitstreamOut->freeMemoryAllocatedForSliceLocations();
-      
+
       //-- For time output for each slice
       Double dEncTime = (double)(clock()-iBeforeTime) / CLOCKS_PER_SEC;
-      
+
       xCalculateAddPSNR( pcPic, pcPic->getPicYuvRec(), pcBitstreamOut->getNumberOfWrittenBits(), dEncTime );
-
-#if GERHARD_RM_DEBUG_MM
-      if (m_pcRdCost->getUseRenModel() )
-      {      
-        TRenModel*  pcMMCheckModel = m_pcEncTop->getEncTop()->getMMCheckModel(); 
-        TRenModel*  pcRenModel     = m_pcEncTop->getEncTop()->getRenModel    (); 
-        TComPicYuv* pcPicYuvRec    = pcPic->getPicYuvRec();         
-        pcMMCheckModel->setData(0,0, pcPicYuvRec->getWidth(), pcPicYuvRec->getHeight(), pcPicYuvRec->getStride(), pcPicYuvRec->getLumaAddr()); 
-        Bool bEqual = pcRenModel->compare( pcMMCheckModel ); 
-
-        if ( !bEqual )
-        {
-          std::cout << "Mismatch in Renderer Model !" << std::endl; 
-        }      
-      }
-#endif
 
 #if FIXED_ROUNDING_FRAME_MEMORY
@@ -643,11 +664,9 @@
       pcBitstreamOut->insertAt(bs_SPS_PPS_SEI, 0);
 
-#if SB_MEM_FIX
       bs_SPS_PPS_SEI.destroy();
-#endif
       pcPic->getPicYuvRec()->copyToPic(pcPicYuvRecOut);
-      
+
       pcPic->setReconMark   ( true );
-      
+
 }
 
@@ -656,12 +675,12 @@
   TComSlice* pcSlice = pcPic->getSlice(pcPic->getCurrSliceIdx());
   Bool bCalcDist = false;
-  
+
   m_pcLoopFilter->setCfg(pcSlice->getLoopFilterDisable(), m_pcCfg->getLoopFilterAlphaC0Offget(), m_pcCfg->getLoopFilterBetaOffget());
   m_pcLoopFilter->loopFilterPic( pcPic );
-  
+
   m_pcEntropyCoder->setEntropyCoder ( m_pcEncTop->getRDGoOnSbacCoder(), pcSlice );
   m_pcEntropyCoder->resetEntropy    ();
   m_pcEntropyCoder->setBitstream    ( m_pcBitCounter );
-  
+
   // Adaptive Loop filter
   if( pcSlice->getSPS()->getUseALF() )
@@ -672,7 +691,7 @@
 #endif
     m_pcAdaptiveLoopFilter->allocALFParam(&cAlfParam);
-    
+
     m_pcAdaptiveLoopFilter->startALFEnc(pcPic, m_pcEntropyCoder);
-    
+
     UInt uiMaxAlfCtrlDepth;
     m_pcAdaptiveLoopFilter->ALFProcess(&cAlfParam, pcSlice->getLambda(), ruiDist, ruiBits, uiMaxAlfCtrlDepth );
@@ -680,8 +699,8 @@
     m_pcAdaptiveLoopFilter->freeALFParam(&cAlfParam);
   }
-  
+
   m_pcEntropyCoder->resetEntropy    ();
   ruiBits += m_pcEntropyCoder->getNumberOfWrittenBits();
-  
+
   if (!bCalcDist)
     ruiDist = xFindDistortionFrame(pcPic->getPicYuvOrg(), pcPic->getPicYuvRec());
@@ -704,11 +723,11 @@
 #endif
   Int   iTemp;
-  
+
   Int   iStride = pcPic0->getStride();
   Int   iWidth  = pcPic0->getWidth();
   Int   iHeight = pcPic0->getHeight();
-  
+
   UInt64  uiTotalDiff = 0;
-  
+
   for( y = 0; y < iHeight; y++ )
   {
@@ -724,12 +743,12 @@
     pSrc1 += iStride;
   }
-  
+
   iHeight >>= 1;
   iWidth  >>= 1;
   iStride >>= 1;
-  
+
   pSrc0  = pcPic0->getCbAddr();
   pSrc1  = pcPic1->getCbAddr();
-  
+
   for( y = 0; y < iHeight; y++ )
   {
@@ -745,8 +764,8 @@
     pSrc1 += iStride;
   }
-  
+
   pSrc0  = pcPic0->getCrAddr();
   pSrc1  = pcPic1->getCrAddr();
-  
+
   for( y = 0; y < iHeight; y++ )
   {
@@ -762,5 +781,5 @@
     pSrc1 += iStride;
   }
-  
+
   return uiTotalDiff;
 }
@@ -772,22 +791,22 @@
   UInt64 uiSSDU  = 0;
   UInt64 uiSSDV  = 0;
-  
+
   Double  dYPSNR  = 0.0;
   Double  dUPSNR  = 0.0;
   Double  dVPSNR  = 0.0;
-  
+
   //===== calculate PSNR =====
   Pel*  pOrg    = pcPic ->getPicYuvOrg()->getLumaAddr();
   Pel*  pRec    = pcPicD->getLumaAddr();
   Int   iStride = pcPicD->getStride();
-  
+
   Int   iWidth;
   Int   iHeight;
-  
+
   iWidth  = pcPicD->getWidth () - m_pcEncTop->getPad(0);
   iHeight = pcPicD->getHeight() - m_pcEncTop->getPad(1);
-  
+
   Int   iSize   = iWidth*iHeight;
-  
+
   UInt   maxval = 255 * (1<<(g_uiBitDepth + g_uiBitIncrement -8));
   Double fRefValueY = (double) maxval * maxval * iSize;
@@ -804,11 +823,11 @@
     pRec += iStride;
   }
-  
-
+
+#if HHI_VSO
   if ( m_pcRdCost->getUseRenModel() )
   {
-    TRenModel*  pcRenModel = m_pcEncTop->getEncTop()->getRenModel();        
-    Int64 iDistVSOY, iDistVSOU, iDistVSOV; 
-    pcRenModel->getTotalSSE( iDistVSOY, iDistVSOU, iDistVSOV ); 
+    TRenModel*  pcRenModel = m_pcEncTop->getEncTop()->getRenModel();
+    Int64 iDistVSOY, iDistVSOU, iDistVSOV;
+    pcRenModel->getTotalSSE( iDistVSOY, iDistVSOU, iDistVSOV );
     dYPSNR = ( iDistVSOY ? 10.0 * log10( fRefValueY / (Double) iDistVSOY ) : 99.99 );
     dUPSNR = ( iDistVSOU ? 10.0 * log10( fRefValueC / (Double) iDistVSOU ) : 99.99 );
@@ -816,5 +835,6 @@
   }
   else
-  {   
+#endif
+  {
   iHeight >>= 1;
   iWidth  >>= 1;
@@ -822,5 +842,5 @@
   pOrg  = pcPic ->getPicYuvOrg()->getCbAddr();
   pRec  = pcPicD->getCbAddr();
-  
+
   for( y = 0; y < iHeight; y++ )
   {
@@ -833,8 +853,8 @@
     pRec += iStride;
   }
-  
+
   pOrg  = pcPic ->getPicYuvOrg()->getCrAddr();
   pRec  = pcPicD->getCrAddr();
-  
+
   for( y = 0; y < iHeight; y++ )
   {
@@ -851,8 +871,7 @@
   dVPSNR            = ( uiSSDV ? 10.0 * log10( fRefValueC / (Double)uiSSDV ) : 99.99 );
   }
-  
   // fix: total bits should consider slice size bits (32bit)
   uibits += 32;
-  
+
 #if RVM_VCEGAM10
   m_vRVM_RP.push_back( uibits );
@@ -906,5 +925,5 @@
   printf( "[Y %6.4lf dB    U %6.4lf dB    V %6.4lf dB]  ", dYPSNR, dUPSNR, dVPSNR );
   printf ("[ET %5.0f ] ", dEncTime );
-  
+
   for (Int iRefList = 0; iRefList < 2; iRefList++)
   {
@@ -972,5 +991,5 @@
 {
   Double dRVM = 0;
-  
+
   //if( m_pcCfg->getGOPSize() == 1 && m_pcCfg->getIntraPeriod() != 1 && m_pcCfg->getFrameToBeEncoded() > RVM_VCEGAM10_M * 2 )
   {
@@ -980,5 +999,5 @@
     vRL.resize( N );
     vB.resize( N );
-    
+
     Int i;
     Double dRavg = 0 , dBavg = 0;
@@ -994,8 +1013,8 @@
       dBavg += vB[i];
     }
-    
+
     dRavg /= ( N - 2 * RVM_VCEGAM10_M );
     dBavg /= ( N - 2 * RVM_VCEGAM10_M );
-    
+
     double dSigamB = 0;
     for( i = RVM_VCEGAM10_M + 1 ; i < N - RVM_VCEGAM10_M + 1 ; i++ )
@@ -1005,10 +1024,10 @@
     }
     dSigamB = sqrt( dSigamB / ( N - 2 * RVM_VCEGAM10_M ) );
-    
+
     double f = sqrt( 12.0 * ( RVM_VCEGAM10_M - 1 ) / ( RVM_VCEGAM10_M + 1 ) );
-    
+
     dRVM = dSigamB / dRavg * f;
   }
-  
+
   return( dRVM );
 }
Index: trunk/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncGOP.h	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncGOP.h	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 
 
@@ -57,6 +90,10 @@
   TEncBinCABAC*           m_pcBinCABAC;
   TComLoopFilter*         m_pcLoopFilter;
+#if DEPTH_MAP_GENERATION
   TComDepthMapGenerator*  m_pcDepthMapGenerator;
+#endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   TComResidualGenerator*  m_pcResidualGenerator;
+#endif
   
   // Adaptive Loop filter
